package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEPARROQUIA*/
@Entity(name="TgeneParroquia")
@Table(name="TGENEPARROQUIA")
public class TgeneParroquia extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneParroquia
*/
@EmbeddedId
private TgeneParroquiaKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="DESCRIPTION", nullable=true)

/**
* Nombre de la parroquia
*/
private String description;

/**Contructor por defecto*/
public TgeneParroquia(){
}
/**Contructor de TgeneParroquia
@param pPk Clave Primaria del entity
*/
public TgeneParroquia(TgeneParroquiaKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneParroquia
*/
public static TgeneParroquia find(EntityManager pEntityManager,TgeneParroquiaKey pKey) throws Exception{
    TgeneParroquia obj = pEntityManager.find(TgeneParroquia.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneParroquia
@return El objeto que referencia a la Clave primaria de TgeneParroquia
*/
public TgeneParroquiaKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneParroquia
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneParroquia
*/
public void setPk(TgeneParroquiaKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneParroquia))return false;
    TgeneParroquia that = (TgeneParroquia) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneParroquia
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneParroquia
*/
public Object createInstance(){
 TgeneParroquia instance=new TgeneParroquia();	
 instance.setPk(new TgeneParroquiaKey());
 return instance;
}
/**Clona la entidad TgeneParroquia
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneParroquia p=(TgeneParroquia)this.clone();
  p.setPk((TgeneParroquiaKey)this.pk.cloneMe());
  return p;
}
}
